// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUISection;
import org.apache.myfaces.tobago.model.CollapseMode;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
 Renders a section or subsection.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.SectionTagDeclaration}.
 */
@Generated("component.stg")
public class UISection
    extends AbstractUISection implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.section;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.Section";


  enum PropertyKeys {
    image,
    autoSpacing,
    markup,
    level,
    collapsed,
    customClass,
    tip,
    label,
    collapsedMode,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Url to an image to display.

  */
  public java.lang.String getImage() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.image);
  }

  public void setImage(java.lang.String image) {
    getStateHelper().put(PropertyKeys.image, image);
  }

  /**
  Automatically add spacing (margins/paddings) to the component for better positioning.
   Default is 'true' except the component is inside a:
   - header
   - footer
   - bar
   - sheet
   - tree
   - link group
   - button group
   - before facet
   - after facet
   - label facet
   - bar facet

  */
  public Boolean getAutoSpacing() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.autoSpacing);
    if (bool != null) {
      return bool;
    }
    return null;
  }

  public void setAutoSpacing(Boolean autoSpacing) {
    getStateHelper().put(PropertyKeys.autoSpacing, autoSpacing);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Level of the title. Lower value means bigger title, greater value means smaller title.
   Value goes from 1 to 6.

  */
  public java.lang.Integer getLevel() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.level);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setLevel(java.lang.Integer level) {
    getStateHelper().put(PropertyKeys.level, level);
  }

  /**
  Indicating the collapsed state of this component.
  <br>Default: <code>false</code>
  */
  public boolean isCollapsed() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.collapsed);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setCollapsed(boolean collapsed) {
    getStateHelper().put(PropertyKeys.collapsed, collapsed);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  A localized user presentable label for this component.

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  /**
  Enum indicating the mode of the collapsed state of this component.
  <br>Default: <code>none</code>
  */
  public org.apache.myfaces.tobago.model.CollapseMode getCollapsedMode() {
    org.apache.myfaces.tobago.model.CollapseMode collapsedMode = (org.apache.myfaces.tobago.model.CollapseMode) getStateHelper().eval(PropertyKeys.collapsedMode);
    if (collapsedMode != null) {
      return collapsedMode;
    }
    return org.apache.myfaces.tobago.model.CollapseMode.none;
  }

  public void setCollapsedMode(org.apache.myfaces.tobago.model.CollapseMode collapsedMode) {
    getStateHelper().put(PropertyKeys.collapsedMode, collapsedMode);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}